# coding: utf-8

"""
    Collibra Protect API - Partner

    API to retrieve the data access rule set it needs to synchronize. This API is targeted to be used by Collibra Partners.  # noqa: E501

    OpenAPI spec version: 1.0.0-beta
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DatabaseColumn(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'data_type': 'str',
        'precision': 'int',
        'scale': 'int',
        'tags': 'list[DatabaseColumnTag]',
        'accesses': 'list[DatabaseColumnAccessRule]'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'data_type': 'dataType',
        'precision': 'precision',
        'scale': 'scale',
        'tags': 'tags',
        'accesses': 'accesses'
    }

    def __init__(self, id=None, name=None, data_type=None, precision=None, scale=None, tags=None, accesses=None):  # noqa: E501
        """DatabaseColumn - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._data_type = None
        self._precision = None
        self._scale = None
        self._tags = None
        self._accesses = None
        self.discriminator = None
        self.id = id
        self.name = name
        if data_type is not None:
            self.data_type = data_type
        if precision is not None:
            self.precision = precision
        if scale is not None:
            self.scale = scale
        self.tags = tags
        self.accesses = accesses

    @property
    def id(self):
        """Gets the id of this DatabaseColumn.  # noqa: E501

        The id of the database column  # noqa: E501

        :return: The id of this DatabaseColumn.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DatabaseColumn.

        The id of the database column  # noqa: E501

        :param id: The id of this DatabaseColumn.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this DatabaseColumn.  # noqa: E501

        The name of the database column  # noqa: E501

        :return: The name of this DatabaseColumn.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DatabaseColumn.

        The name of the database column  # noqa: E501

        :param name: The name of this DatabaseColumn.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def data_type(self):
        """Gets the data_type of this DatabaseColumn.  # noqa: E501

        The data type as it is declared by the provider. For example: String, Integer, Varchar, Blob, Boolean, ...   # noqa: E501

        :return: The data_type of this DatabaseColumn.  # noqa: E501
        :rtype: str
        """
        return self._data_type

    @data_type.setter
    def data_type(self, data_type):
        """Sets the data_type of this DatabaseColumn.

        The data type as it is declared by the provider. For example: String, Integer, Varchar, Blob, Boolean, ...   # noqa: E501

        :param data_type: The data_type of this DatabaseColumn.  # noqa: E501
        :type: str
        """

        self._data_type = data_type

    @property
    def precision(self):
        """Gets the precision of this DatabaseColumn.  # noqa: E501

        The precision of the column.  # noqa: E501

        :return: The precision of this DatabaseColumn.  # noqa: E501
        :rtype: int
        """
        return self._precision

    @precision.setter
    def precision(self, precision):
        """Sets the precision of this DatabaseColumn.

        The precision of the column.  # noqa: E501

        :param precision: The precision of this DatabaseColumn.  # noqa: E501
        :type: int
        """

        self._precision = precision

    @property
    def scale(self):
        """Gets the scale of this DatabaseColumn.  # noqa: E501

        The scale of the column.  # noqa: E501

        :return: The scale of this DatabaseColumn.  # noqa: E501
        :rtype: int
        """
        return self._scale

    @scale.setter
    def scale(self, scale):
        """Sets the scale of this DatabaseColumn.

        The scale of the column.  # noqa: E501

        :param scale: The scale of this DatabaseColumn.  # noqa: E501
        :type: int
        """

        self._scale = scale

    @property
    def tags(self):
        """Gets the tags of this DatabaseColumn.  # noqa: E501


        :return: The tags of this DatabaseColumn.  # noqa: E501
        :rtype: list[DatabaseColumnTag]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this DatabaseColumn.


        :param tags: The tags of this DatabaseColumn.  # noqa: E501
        :type: list[DatabaseColumnTag]
        """
        if tags is None:
            raise ValueError("Invalid value for `tags`, must not be `None`")  # noqa: E501

        self._tags = tags

    @property
    def accesses(self):
        """Gets the accesses of this DatabaseColumn.  # noqa: E501


        :return: The accesses of this DatabaseColumn.  # noqa: E501
        :rtype: list[DatabaseColumnAccessRule]
        """
        return self._accesses

    @accesses.setter
    def accesses(self, accesses):
        """Sets the accesses of this DatabaseColumn.


        :param accesses: The accesses of this DatabaseColumn.  # noqa: E501
        :type: list[DatabaseColumnAccessRule]
        """
        if accesses is None:
            raise ValueError("Invalid value for `accesses`, must not be `None`")  # noqa: E501

        self._accesses = accesses

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DatabaseColumn, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DatabaseColumn):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
